Texture2D rangeTexture;
SamplerState linearSampler;

RWStructuredBuffer<float4> rangeBuffer;

[numthreads(1, 1, 1)]
void main(uint3 gid : SV_GroupID, uint3 dtid : SV_DispatchThreadID)
{
  float2 dimensions;
  rangeTexture.GetDimensions(dimensions.x, dimensions.y);

  int xMin = (dimensions.x / NUM_GROUPS) * gid.x;
  int yMin = (dimensions.y / NUM_GROUPS) * gid.y;

  int xMax = (dimensions.x / NUM_GROUPS) * (gid.x + 1);
  int yMax = (dimensions.y / NUM_GROUPS) * (gid.y + 1);

  float2 range = { 100000, -100000 };

  for (int y = yMin; y < yMax; ++y) {
    for (int x = xMin; x < xMax; ++x) {
      float4 value = rangeTexture.Load(int3(x, y, 0));

      if (value.a != 0 && value.b == -2) { //sometimes background interfers with range, so chekc for special b value
        range.x = min(range.x, value.x);
        range.y = max(range.y, value.x);
      }
    }
  }
  
  rangeBuffer[gid.y * NUM_GROUPS + gid.x] = float4(range, 0, 0);
}
