cbuffer NormalLevelParameters
{
  float4x4 projectionMatrix;
  float2 oneOverHeightMapSize;

  float heightExaggeration;
  float postDelta;
};

cbuffer NormalUpdateParameters
{
  float2 updateSize;
  float2 origin;
};

struct VertexOut
{
  float4 Position : SV_Position;
  float2 TextureCoordinates : TEXCOORD0;
};

float2 convertTexCoords(float2 texCoords)
{
#ifdef COGS_SHADER_GL
  return texCoords;
#else
  return float2(0, 1) + float2(1, -1) * texCoords;
#endif
}

VertexOut main(float4 Position : POSITION0)
{
  VertexOut Out = (VertexOut)0;

  float2 coordinates = Position.xy * updateSize + origin;

  Out.TextureCoordinates = convertTexCoords(coordinates * oneOverHeightMapSize);
  Out.Position = mul(float4(coordinates, 0.0, 1.0), projectionMatrix);

  return Out;
}
