cbuffer Globals
{
  float4x4 projectionMatrix;
  float4 diffuseColor;
};

struct VS_INPUT
{
  float4 Position : POSITION0;
  float2 TexCoord : TEXCOORD0;
};

struct VS_OUTPUT
{
  float4 Position : SV_Position;
  float2 TexCoord : TEXCOORD0;
};

VS_OUTPUT main(VS_INPUT Input)
{
  VS_OUTPUT Out = (VS_OUTPUT)0;

  Out.Position = mul(Input.Position, projectionMatrix);
  Out.TexCoord = Input.TexCoord.xy;

  return Out;
}
