#include "Terrain/ConstantBuffers.hlsl"
#include "Terrain/ClipmapCommonPS.hlsl"
#include "Terrain/ClipmapNormals.hlsl"
#include "Terrain/ComputeColor.hlsl"

#ifdef CUSTOM_COMPUTE_COLOR
CUSTOM_COMPUTE_COLOR
#endif

SurfaceOut surfaceFunction(in VertexIn In)
{

#ifdef CUSTOM_COMPUTE_COLOR
  float4 color = computeCustomColor(In);
#else
  float4 color = computeDiffuseColor(In);
#endif

  if (!testClipping(In) || color.a < 0.001)
  {
    discard;
  }

  SurfaceOut Out = (SurfaceOut)0;
  Out.Color = color;
  Out.Normal = computeNormal(In, 1);

  return Out;
}
