uniform float4x4 projectionMatrix;

uniform float2 u_sourceOrigin;

struct VertexOut
{
  float4 Position : SV_Position;
  float2 TextureCoordinates : TEXCOORD0;
};

VertexOut main(float2 Position : POSITION0)
{
  VertexOut Out = (VertexOut)0;

  Out.Position = mul(float4(Position, 0.0, 1.0), projectionMatrix);
  Out.TextureCoordinates = (Position * 0.5 + u_sourceOrigin);

  return Out;
}
